# EAAPI

These scripts should be considered complementary to the documentation, not the
other way round. Experimental or unconfirmed this may be present here, however
the doc pages should for the most part only contain confirmed information.

If you came here looking for a complete e-Amusement implementation, you
probably want https://github.com/DragonMinded/bemaniutils instead.

# Requirements
Rather than rolling my own ARC4 and Triple-DES implementations (why does everyone seem to do that?)
I instead opted to just use `pycryptodome`. `lxml` is required for the parsing of string packets,
but is not a hard dependency.

# Keys
In order to run this code, some encryption keys need loaded in. I have opted to not include them in
this repo because I didn't really feel like doing that. May or may not change that stance later.

For now, copy `eaapi/keys.template.py` to `eaapi/keys.py`, and fill in the blanks. If you're
following along with docs, you already have the values you need. Otherwise, I trust you can figure
out somewhere to find them. `CARDCONV_KEY` is only required if you plan to make use of `cardconv`.

## `eaapi/`
The actual implementation of stuff.

## `tests/`
An incredibly incomplete test suite. Run with `test` if you're on windows and lazy.

## `server-dummy/`
A super barebones e-Amusement server that's able to start a surprising number of games.
Largely exists as a proof of concept, and as a testing ground for specific endpoints without having
the overhead of an entire EA server running.

## `server/`
A less barebones server, used for experiementing with more complex behaviours. This probably won't
get pushed until it's had a significant tidy.

## `proxy/`
An e-Amusement server designed to proxy requests to a different upstream server, while allowing the
observation of requests as they're made. As above, probably won't push this for a bit.
